//------------------------------------------------------------------------------------------------
//
//   JoffMode - Class Transformer
//
//------------------------------------------------------------------------------------------------

package gcewing.joffmode;

import java.io.*;
import java.util.*;
import java.util.zip.*;
import net.minecraft.launchwrapper.*;

public class JMClassTransformer implements IClassTransformer {

	static void peekHex(byte[] d) {
		System.out.printf("%02x %02x %02x %02x %02x %02x %02x %02x\n",
			d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7]);
	}
	
	static void dumpData(byte[] data, String path) {
		try {
			FileOutputStream out = new FileOutputStream(path);
			out.write(data);
			out.close();
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public byte[] transform(String obfName, String deobfName, byte[] data) {
		byte[] newData = readClassFromJar(deobfName);
		if (newData != null) {
			//System.out.printf("JoffMode: JMClassTransformer.transform %s called with %d bytes of data\n",
			//	deobfName, data.length);
			//peekHex(data);
			//dumpData(data, deobfName + ".old");
			//System.out.printf("JoffMode: JMClassTransformer.transform: Replacing with %d bytes of new data\n",
			//	newData.length);
			//peekHex(newData);
			//dumpData(newData, deobfName + ".new");
			return newData;
		}
		return data;
	}
	
	byte[] readClassFromJar(String name) {
		//System.out.printf("JoffMode: JMClassTransformer.readClassFromJar: %s\n", name);
		ZipFile zip = JMLoadingPlugin.zip;
		try {
			ZipEntry entry = zip.getEntry(name.replace('.', '/') + ".data");
			if (entry != null) {
				System.out.printf("JoffMode: JMClassTransformer.readClassFromJar: Found %s\n", name);
				InputStream zin = zip.getInputStream(entry);
				int size = (int)entry.getSize();
				byte[] bytes = new byte[size];
				int nread = 0;
				while (nread < size)
					nread += zin.read(bytes, nread, size - nread);
				zin.close();
				System.out.printf("JoffMode: Replaced %s\n", name);
				return bytes;
			}
			else
				return null;
		}
		catch (Exception e) {
			throw new RuntimeException("JoffMode: Error overriding " + name + " from " + JMLoadingPlugin.location.getName(), e);
		}
	}

}
